/*	$Id: types_fwd.h 3090 2006-01-10 17:07:17Z jgressma $
 *
 *  Copyright 2005 University of Potsdam, Germany
 * 
 *	This file is part of Platypus.
 *
 *  Platypus is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  Platypus is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Platypus; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 */

#ifndef PLATYPUS_TYPES_FWD_H
#define PLATYPUS_TYPES_FWD_H

namespace Platypus
{
	class DistributionBase;
	class ProgramInterface;
	class PlatypusOptions;
	class PlatypusTypesFactory;
	class Expander;
	class PartialAssignment;
	class ChoicesToDo;
	class Atom;
	class ProbingManager;
	class Branch;
	class SearchSpace;
	class Program;
	namespace DelegatableChoicePolicy
	{
		class PolicyBase;
		class Random;
		class Largest;
		class Smallest;
	}
	namespace ProbingPolicy
	{
		class PolicyBase;
		class Null;
		class Largest;
	}
	namespace ChoicePolicy
	{
		class PolicyBase;
		class RandomTrue;
		class RandomFalse;
		class RandomRandom;
	}
}

#endif
