/*  Copyright (c) October 2005 Jean Gressmann (jsg@rz.uni-potsdam.de)
 *
 *  This is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2 of the License, or
 *	(at your option) any later version. 
 * 
 *	This file is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this file; if not, write to the Free Software
 *	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <portablethreads/exception.h>

namespace PortableThreads 
{

	PTException::PTException(const std::string& reason)
		:	std::runtime_error(reason)
	{}
	void PTException::raise() { throw *this; }
	PTException* PTException::clone() const { return new PTException(*this); }

	PTParameterError::PTParameterError(const std::string& reason)
		:	PTException(reason)
	{}
	void PTParameterError::raise() { throw *this; }
	PTException* PTParameterError::clone() const { return new PTParameterError(*this); }



	PTResourceError::PTResourceError(const std::string& reason)
		:	PTException(reason)
	{}
	void PTResourceError::raise() { throw *this; }
	PTException* PTResourceError::clone() const { return new PTResourceError(*this); }

}

